diff -r -c bash-1_14_7/execute_cmd.c bash1147/execute_cmd.c
*** bash-1_14_7/execute_cmd.c	Wed Mar 10 09:43:46 1999
--- bash1147/execute_cmd.c	Fri Mar 19 17:49:29 1999
***************
*** 33,39 ****
--- 33,41 ----
  #define SIGABRT SIGIOT
  #endif
  
+ #if !defined (VMS)
  #include <sys/param.h>
+ #endif
  #include <errno.h>
  
  #if !defined (errno)
***************
*** 46,53 ****
--- 48,64 ----
  #  include <strings.h>
  #endif /* !HAVE_STRING_H */
  
+ #ifdef VMS
+ #include <wait.h>
+ #include <climsgdef>
+ #endif
+ 
  #include "shell.h"
+ #if defined (VMS)
+ #include "y_tab.h"
+ #else
  #include "y.tab.h"
+ #endif
  #include "flags.h"
  #include "hash.h"
  #include "jobs.h"
***************
*** 92,97 ****
--- 103,124 ----
  static int execute_builtin_or_function (), add_undo_redirect ();
  static char *find_user_command_internal (), *find_user_command_in_path ();
  
+ #if defined (USE_VMS)
+ #include <stdlib.h>
+ #include "vmsutil.h"
+ #include "trap.h"
+ static int check_batch_file (char *filename);
+ static void expand_words_for_internal_command (WORD_LIST *words);
+ static void expand_arguments_for_external_command (WORD_LIST *words, char **args,
+ 						   char **except);
+ static void maybe_expand_arguments (WORD_LIST *words, char *command, char **args);
+ extern char *extract_unit (char *string, int *p_index, int separator);
+ extern int subshell_exit_value;
+ extern int subshell_exit_builtin;
+ extern int subshell_skip_commands;
+ extern int startup_state;
+ #endif
+ 
  /* The line number that the currently executing function starts on. */
  static int function_line_number = 0;
  
***************
*** 129,134 ****
--- 156,169 ----
  
  struct fd_bitmap *current_fds_to_close = (struct fd_bitmap *)NULL;
  
+ int
+ debug_getname (fd)
+      int fd;
+ {
+   char buffer[256];
+   fprintf (stderr, "fd - %d: %s\n", fd, getname (fd, buffer));
+ }
+ 
  #define FD_BITMAP_DEFAULT_SIZE 32
  /* Functions to allocate and deallocate the structures used to pass
     information from the shell to its children about file descriptors
***************
*** 178,183 ****
--- 213,291 ----
      }
  }
  
+ #if defined (USE_VMS)
+ static int delay_remove_size = 0;
+ static int delay_remove_counts = 0;
+ static char **delay_remove_filenames = NULL;
+ #define DELAY_REMOVE_DEFAULT_SIZE 5 /* at least size */
+ 
+ static void
+ add_delay_remove (const char *filename)
+ {
+   int i;
+ 
+   if (delay_remove_filenames == NULL)
+     {
+       delay_remove_size = DELAY_REMOVE_DEFAULT_SIZE;
+       delay_remove_counts = 0;
+       delay_remove_filenames = (char **) xmalloc (sizeof (char *)
+ 						  * delay_remove_size);
+       for (i = 0; i < delay_remove_size; i++)
+ 	delay_remove_filenames[i] = NULL;
+     }
+   else if (delay_remove_size >= delay_remove_counts)
+     {
+       delay_remove_size *= 2;
+       delay_remove_filenames = (char **) xrealloc (delay_remove_filenames,
+ 						   sizeof (char *)
+ 						   * delay_remove_size);
+       for (i = delay_remove_counts; i < delay_remove_size; i++)
+ 	delay_remove_filenames[i] = NULL;
+     }
+ 
+   for (i = 0; i < delay_remove_size; i++)
+     if (delay_remove_filenames[i] == NULL)
+       {
+ 	delay_remove_filenames[i] = savestring (filename);
+ 	delay_remove_counts++;
+ 	break;
+       }
+ }
+ 
+ static void
+ try_delay_remove (void)
+ {
+   int i;
+ 
+   if (delay_remove_counts == 0)
+     return;
+ 
+   /* search and delete if found */
+   for (i = 0; i < delay_remove_size; i++)
+     {
+       if (delay_remove_filenames[i] == NULL)
+ 	continue;
+ 
+       if (remove (delay_remove_filenames[i]) == 0)
+ 	{
+ 	  free (delay_remove_filenames[i]);
+ 	  delay_remove_filenames[i] = NULL;
+ 	  delay_remove_counts--;
+ 	}
+     }
+ 
+   if (delay_remove_counts == 0
+       && delay_remove_size != DELAY_REMOVE_DEFAULT_SIZE)
+     {
+       /* shrink array size */
+       delay_remove_size = DELAY_REMOVE_DEFAULT_SIZE;
+       delay_remove_filenames = (char **) xrealloc (delay_remove_filenames,
+ 						   sizeof (char *)
+ 						   * delay_remove_size);
+     }
+ }
+ #endif
+ 
  /* Execute the command passed in COMMAND.  COMMAND is exactly what
     read_command () places into GLOBAL_COMMAND.  See "command.h" for the
     details of the command structure.
***************
*** 190,195 ****
--- 298,306 ----
  {
    struct fd_bitmap *bitmap;
    int result;
+ #if defined (USE_VMS)
+   int pipes = vmsutil_pipe_no ();
+ #endif
  
    current_fds_to_close = (struct fd_bitmap *)NULL;
    bitmap = new_fd_bitmap (FD_BITMAP_DEFAULT_SIZE);
***************
*** 205,210 ****
--- 316,325 ----
  #if defined (PROCESS_SUBSTITUTION)
    unlink_fifo_list ();
  #endif /* PROCESS_SUBSTITUTION */
+ #if defined (USE_VMS)
+   vmsutil_pipe_clean (pipes);
+   try_delay_remove ();
+ #endif
  
    return (result);
  }
***************
*** 283,289 ****
--- 398,408 ----
    fprintf (stderr, "pid %d open files:", getpid ());
    for (i = 3; i < fd_table_size; i++)
      {
+ #if defined (USE_VMS)
+       if ((f = vmsfcntl (i, F_GETFD, 0)) != -1)
+ #else
        if ((f = fcntl (i, F_GETFD, 0)) != -1)
+ #endif
  	fprintf (stderr, " %d (%s)", i, f ? "close" : "open");
      }
    fprintf (stderr, "\n");
***************
*** 314,319 ****
--- 433,442 ----
    int invert, ignore_return;
    REDIRECT *my_undo_list, *exec_undo_list;
  
+ #if defined (USE_VMS)
+   if (subshell_skip_commands)
+     return (EXECUTION_SUCCESS);
+ #endif
    if (!command || breaking || continuing)
      return (EXECUTION_SUCCESS);
  
***************
*** 331,349 ****
--- 454,502 ----
         (pipe_out != NO_PIPE || pipe_in != NO_PIPE || asynchronous)))
      {
        pid_t paren_pid;
+ #if defined (USE_VMS)
+       COMMAND *old_command;
+       OLDENVBUF oldenvbuf;
+ #endif
+ 
+ #if defined (USE_VMS)
+ 	/* save arg list */
+ 	old_command = command;
+ 	command = copy_command (old_command);
  
+ 	/* save fd, jmp_buf, current directory, global variables */
+ 	vmsutil_save_all_environment (&oldenvbuf);
+ #endif
        /* Fork a subshell, turn off the subshell bit, turn off job
  	 control and call execute_command () on the command again. */
        paren_pid = make_child (savestring (make_command_string (command)),
  			      asynchronous);
+ #if defined (USE_VMS)
+       /* force execute in parent shell */
+       if (paren_pid != 0)
+ #else
        if (paren_pid == 0)
+ #endif
  	{
  	  int user_subshell, return_code, function_value;
+ #if defined (USE_VMS)
+ 	  char *old_trap_list[1];
+ 	  int old_sigmodes[1];
+ #endif
+ 
+ #if defined (USE_VMS)
+ 	  /* save signal */
+ 	  old_trap_list[0] = trap_list[0] ? savestring (trap_list[0]) : NULL;
+ 	  old_sigmodes[0] = vmsutil_get_signal_modes (0);
  
+ 	  /* Cancel exit trap */
+ 	  restore_default_signal (0);
+ #else
  	  /* Cancel traps, in trap.c. */
  	  restore_original_signals ();
  	  if (asynchronous)
  	    setup_async_signals ();
+ #endif
  
  #if defined (JOB_CONTROL)
  	  set_sigchld_handler ();
***************
*** 427,433 ****
--- 580,593 ----
  	  if (command->redirects)
  	    {
  	      if (do_redirections (command->redirects, 1, 0, 0) != 0)
+ #if defined (USE_VMS)
+ 		{
+ 		  vmsutil_wait_status = (EXECUTION_FAILURE);
+ 		  goto _exec1_return;
+ 		}
+ #else
  		exit (EXECUTION_FAILURE);
+ #endif
  
  	      dispose_redirects (command->redirects);
  	      command->redirects = (REDIRECT *)NULL;
***************
*** 448,458 ****
--- 608,636 ----
  	  if (return_catch_flag)
  	    function_value =  setjmp (return_catch);
  
+ #if defined (USE_VMS)
+ 	  begin_unwind_frame ("subshell-execute-command");
+ 	  unwind_protect_int (subshell_exit_value);
+ 	  unwind_protect_int (subshell_exit_builtin);
+ 	  unwind_protect_int (subshell_skip_commands);
+ 
+ 	  subshell_exit_value = 0;
+ 	  subshell_exit_builtin = 1;
+ 	  subshell_skip_commands = 0;
+ #endif
  	  if (function_value)
  	    return_code = return_catch_value;
  	  else
  	    return_code = execute_command_internal
  	      (command, asynchronous, NO_PIPE, NO_PIPE, fds_to_close);
+ #if defined (USE_VMS)
+ 	  if (subshell_skip_commands)
+ 	    {
+ 	      return_code = subshell_exit_value;
+ 	      last_command_exit_value = return_code;
+ 	    }
+ 	  run_unwind_frame ("subshell-execute-command");
+ #endif
  
  	  /* If we were explicitly placed in a subshell with (), we need
  	     to do the `shell cleanup' things, such as running traps[0]. */
***************
*** 462,471 ****
--- 640,672 ----
  	      return_code = run_exit_trap ();
  	    }
  
+ #if defined (USE_VMS)
+ 	  vmsutil_wait_status = return_code << 8;
+ 
+ _exec1_return:
+ 	  /* restore signal */
+ 	  restore_default_signal (0);
+ 	  trap_list[0] = old_trap_list[0];
+ 	  vmsutil_set_signal_modes (0, old_sigmodes[0]);
+ 
+ 	  /* restore fd, jmp_buf, current directory, global variables */
+ 	  vmsutil_restore_all_environment (&oldenvbuf);
+ 
+ 	  /* restore arg list */
+ 	  dispose_command (command);
+ 	  command = old_command;
+ 
+ 	  goto _subshell_parent;
+ #else
  	  exit (return_code);
+ #endif
  	}
        else
  	{
+ #if defined (USE_VMS)
+ 	  /* parent side */
+ _subshell_parent:
+ #endif
  	  close_pipes (pipe_in, pipe_out);
  
  #if defined (PROCESS_SUBSTITUTION) && defined (HAVE_DEV_FD)
***************
*** 504,509 ****
--- 705,714 ----
  
  	      return (EXECUTION_SUCCESS);
  	    }
+ #if defined (USE_VMS)
+ 	/* return in parent */
+ 	return (0);
+ #endif
  	}
      }
  
***************
*** 668,673 ****
--- 873,884 ----
  	    if (asynchronous)
  	      {
  		DESCRIBE_PID (last_made_pid);
+ #if defined (USE_VMS)
+ 		last_made_pid = NO_PID;
+ #if 0
+ 		last_asynchronous_pid = NO_PID;
+ #endif /* 0 */
+ #endif
  	      }
  	    else
  #if !defined (JOB_CONTROL)
***************
*** 700,705 ****
--- 911,919 ----
  	  {
  	    COMMAND *tc = command->value.Connection->first;
  	    REDIRECT *rp;
+ #if defined (USE_VMS)
+ 	    int ofd = -1;
+ #endif
  
  	    if (!tc)
  	      break;
***************
*** 723,728 ****
--- 937,950 ----
  	    {
  	      REDIRECT *tr;
  
+ #if defined (USE_VMS)
+ #if 0
+ 	      /* save stdin */
+ 	      if ((ofd = dup (0)) < 0)
+ 		internal_error ("cannot duplicate fd 0: %s",
+ 			strerror (errno));
+ #endif /* 0 */
+ #endif
  	      rd.filename = make_word ("/dev/null");
  	      tr = make_redirection (0, r_inputa_direction, rd);
  	      tr->next = tc->redirects;
***************
*** 744,749 ****
--- 966,985 ----
  		 multiple times with the same command. */
  	      REDIRECT *tr, *tl;
  
+ #if defined (USE_VMS)
+ #if 0
+ 	      /* restore stdin */
+ 	      if (ofd >= 0)
+ 		{
+ 		  if (dup2 (ofd, 0) < 0)
+ 		    internal_error ("cannot duplicate fd %d to fd 0: %s",
+ 					ofd, strerror (errno));
+ 		  close (ofd);
+ 		  ofd = -1;
+ 		}
+ #endif 
+ #endif
+ 
  	      tr = tc->redirects;
  	      do
  		{
***************
*** 811,817 ****
--- 1047,1057 ----
  		   cmd->value.Connection->connector == '|')
  	      {
  		/* Make a pipeline between the two commands. */
+ #if defined (USE_VMS)
+ 		if (vmsutil_pipe (fildes) < 0)
+ #else
  		if (pipe (fildes) < 0)
+ #endif
  		  {
  		    report_error ("pipe error: %s", strerror (errno));
  #if defined (JOB_CONTROL)
***************
*** 852,858 ****
--- 1092,1105 ----
  			    (char *)fd_bitmap->bitmap, fds_to_close->size);
  
  		    /* And mark the pipe file descriptors to be closed. */
+ #if defined (USE_VMS)
+ #if 0
+ 		    /* close pipe in */
  		    fd_bitmap->bitmap[fildes[0]] = 1;
+ #endif /* 0 */
+ #else
+ 		    fd_bitmap->bitmap[fildes[0]] = 1;
+ #endif
  
  		    /* In case there are pipe or out-of-processes errors, we
  		       want all these file descriptors to be closed when
***************
*** 1053,1058 ****
--- 1300,1309 ----
        REAP ();
        QUIT;
  
+ #if defined (USE_VMS)
+       if (subshell_skip_commands)
+ 	break;
+ #endif
        if (breaking)
  	{
  	  breaking--; 
***************
*** 1335,1340 ****
--- 1586,1595 ----
        REAP ();
        QUIT;
  
+ #if defined (USE_VMS)
+       if (subshell_skip_commands)
+ 	break;
+ #endif
        if (breaking)
  	{
  	  breaking--;
***************
*** 1496,1501 ****
--- 1751,1760 ----
        return_value = execute_command (while_command->test);
        REAP ();
  
+ #if defined (USE_VMS)
+       if (subshell_skip_commands)
+ 	break;
+ #endif
        if (type == CMD_WHILE && return_value != EXECUTION_SUCCESS)
  	break;
        if (type == CMD_UNTIL && return_value == EXECUTION_SUCCESS)
***************
*** 1505,1510 ****
--- 1764,1773 ----
        body_status = execute_command (while_command->action);
        QUIT;
  
+ #if defined (USE_VMS)
+       if (subshell_skip_commands)
+ 	break;
+ #endif
        if (breaking)
  	{
  	  breaking--;
***************
*** 1534,1539 ****
--- 1797,1806 ----
    if_command->test->flags |= CMD_IGNORE_RETURN;
    return_value = execute_command (if_command->test);
  
+ #if defined (USE_VMS)
+   if (subshell_skip_commands)
+      return (EXECUTION_SUCCESS);
+ #endif
    if (return_value == EXECUTION_SUCCESS)
      {
        QUIT;
***************
*** 1576,1581 ****
--- 1843,1853 ----
    char *command_line, *lastarg;
    int first_word_quoted, result;
    pid_t old_last_command_subst_pid;
+ #if defined (USE_VMS)
+ #if 0
+   int ofds[3] = { -1, -1, -1 };
+ #endif /* 0 */
+ #endif
  
    result = EXECUTION_SUCCESS;
  
***************
*** 1586,1593 ****
--- 1858,1870 ----
    /* Remember what this command line looks like at invocation. */
    command_string_index = 0;
    print_simple_command (simple_command);
+ #if defined (USE_VMS)
+   /* Expect to call function 'savestring' */
+   command_line = the_printed_command;
+ #else
    command_line = (char *)alloca (1 + strlen (the_printed_command));
    strcpy (command_line, the_printed_command);
+ #endif
  
    first_word_quoted =
      simple_command->words ? simple_command->words->word->quoted : 0;
***************
*** 1730,1735 ****
--- 2007,2018 ----
  	 If so, and we have pipes, then fork a subshell in here.  Else, just
  	 do the command. */
  
+ #if defined (USE_VMS)
+ #if 0
+       save_std_fds (ofds);
+ #endif /* 0 */
+ #endif
+ 
        if (func)
  	builtin = (Function *)NULL;
        else
***************
*** 1742,1748 ****
--- 2025,2035 ----
  	{
  	  if ((pipe_in != NO_PIPE) || (pipe_out != NO_PIPE) || async)
  	    {
+ #if defined (USE_VMS)
+ 	      if (make_child (savestring (command_line), async) != 0)
+ #else
  	      if (make_child (savestring (command_line), async) == 0)
+ #endif
  		{
  		  /* Cancel traps, in trap.c. */
  		  restore_original_signals ();
***************
*** 1750,1759 ****
--- 2037,2057 ----
  		  if (async)
  		    setup_async_signals ();
  
+ #if defined (USE_VMS)
+ 		  expand_words_for_internal_command (words);
+ #endif
  		  execute_subshell_builtin_or_function
  		    (words, simple_command->redirects, builtin, func,
  		     pipe_in, pipe_out, async, fds_to_close,
  		     simple_command->flags);
+ #if defined (USE_VMS)
+ 		  /* execute parent side */
+ 		  close_pipes (pipe_in, pipe_out);
+ #if defined (PROCESS_SUBSTITUTION) && defined (HAVE_DEV_FD)
+ 		  unlink_fifo_list ();
+ #endif
+ 		  goto return_result;
+ #endif
  		}
  	      else
  		{
***************
*** 1766,1782 ****
--- 2064,2112 ----
  	    }
  	  else
  	    {
+ #if defined (USE_VMS)
+ #if 0
+ 	      if (subshell_environment || builtin != exec_builtin)
+ 		save_std_fds (ofds);
+ #endif /* 0 */
+ #endif
+ #if defined (USE_VMS)
+ 	      expand_words_for_internal_command (words);
+ #endif
  	      result = execute_builtin_or_function
  		(words, builtin, func, simple_command->redirects, fds_to_close,
  		 simple_command->flags);
+ #if defined (USE_VMS)
+ #if 0
+ 	      restore_std_fds (ofds);
+ #endif /* 0 */
+ #endif
  
  	      goto return_result;
  	    }
  	}
  
+ #if defined (USE_VMS)
+ #if 0
+       save_std_fds (ofds);
+ #endif /* 0 */
+ #endif
        execute_disk_command (words, simple_command->redirects, command_line,
  			    pipe_in, pipe_out, async, fds_to_close,
  			    (simple_command->flags & CMD_NO_FORK));
+ #if defined (USE_VMS)
+ #if 0
+       restore_std_fds (ofds);
+ #endif /* 0 */
+ 
+       /* sh -c "foo": Return result code */
+       if (startup_state == 2)
+ 	{
+ 	  result = vmsutil_wait_status;
+ 	  if ((result & 0x0000ff00) == 0x0000ff00)
+ 	    result &= 0x000000ff;
+ 	}
+ #endif
  
        goto return_result;
      }
***************
*** 1786,1805 ****
--- 2116,2154 ----
  	 care of it.  Just fork, do piping and redirections, and exit. */
        if (make_child (savestring (""), async) == 0)
  	{
+ #if !(defined (USE_VMS))
  	  /* Cancel traps, in trap.c. */
  	  restore_original_signals ();
+ #endif
  
  	  do_piping (pipe_in, pipe_out);
  
  	  subshell_environment = 1;
  
  	  if (do_redirections (simple_command->redirects, 1, 0, 0) == 0)
+ #if defined (USE_VMS)
+ 	    {
+ 	      vmsutil_wait_status = (EXECUTION_SUCCESS);
+ 	      goto null_return_exit;
+ 	    }
+ #else
  	    exit (EXECUTION_SUCCESS);
+ #endif
  	  else
+ #if defined (USE_VMS)
+ 	    {
+ 	      vmsutil_wait_status = (EXECUTION_FAILURE);
+ 	      goto null_return_exit;
+ 	    }
+ #else
  	    exit (EXECUTION_FAILURE);
+ #endif
  	}
        else
  	{
+ #if defined (USE_VMS)
+ null_return_exit:
+ #endif
  	  close_pipes (pipe_in, pipe_out);
  #if defined (PROCESS_SUBSTITUTION) && defined (HAVE_DEV_FD)
  	  unlink_fifo_list ();
***************
*** 1826,1831 ****
--- 2175,2186 ----
      }
  
   return_result:
+ #if defined (USE_VMS)
+ #if 0
+   restore_std_fds (ofds);
+ #endif /* 0 */
+ #endif
+ 
    bind_lastarg (lastarg);
    /* The unwind-protect frame is set up only if WORDS is not empty. */
    if (words)
***************
*** 1878,1883 ****
--- 2233,2244 ----
  
    result = ((*builtin) (words->next));
  
+ #if defined (USE_VMS)
+   /* check subshell return */
+   if (builtin == exit_builtin && result == EXECUTION_SUCCESS)
+     result = last_command_exit_value;
+ #endif
+ 
    if (subshell == 0 && builtin == source_builtin)
      {
        dispose_builtin_env ();
***************
*** 1999,2004 ****
--- 2360,2373 ----
       struct fd_bitmap *fds_to_close;
       int flags;
  {
+ #if defined (USE_VMS)
+       OLDENVBUF oldenvbuf;
+ #endif
+ 
+ #if defined (USE_VMS)
+   /* save fd, jmp_buf, current directory, global variables */
+   vmsutil_save_all_environment (&oldenvbuf);
+ #endif
    /* A subshell is neither a login shell nor interactive. */
    login_shell = interactive = 0;
  
***************
*** 2029,2035 ****
--- 2398,2411 ----
      close_fd_bitmap (fds_to_close);
  
    if (do_redirections (redirects, 1, 0, 0) != 0)
+ #if defined (USE_VMS)
+     {
+       vmsutil_wait_status = (EXECUTION_FAILURE);
+       goto return_exit;
+     }
+ #else
      exit (EXECUTION_FAILURE);
+ #endif
  
    if (builtin)
      {
***************
*** 2039,2044 ****
--- 2415,2433 ----
  	 so we don't go back up to main(). */
        result = setjmp (top_level);
  
+ #if defined (USE_VMS)
+       if (result == EXITPROG)
+ 	vmsutil_wait_status = (last_command_exit_value);
+       else if (result)
+ 	vmsutil_wait_status = (EXECUTION_FAILURE);
+       else
+ 	vmsutil_wait_status = (execute_builtin (builtin, words, flags, 1));
+     }
+   else
+     {
+       vmsutil_wait_status = (execute_function (var, words, flags, fds_to_close, async, 1));
+     }
+ #else
        if (result == EXITPROG)
  	exit (last_command_exit_value);
        else if (result)
***************
*** 2050,2055 ****
--- 2439,2453 ----
      {
        exit (execute_function (var, words, flags, fds_to_close, async, 1));
      }
+ #endif
+ #if defined (USE_VMS)
+ return_exit:
+   /* restore fd, jmp_buf, current directory, global variables */
+   vmsutil_restore_all_environment (&oldenvbuf);
+ 
+   /* return in subshell */
+   return;
+ #endif
  }
  
  /* Execute a builtin or function in the current shell context.  If BUILTIN
***************
*** 2167,2172 ****
--- 2565,2574 ----
    char *hashed_file, *command, **args;
    int pid, temp_path;
    SHELL_VAR *path;
+ #if defined (USE_VMS)
+   int ofds[3] = { -1, -1, -1 };
+   char *fixp;
+ #endif
  
    pathname = words->word->word;
  #if defined (RESTRICTED_SHELL)
***************
*** 2203,2209 ****
--- 2605,2619 ----
      {
        int st;
  
+ #if defined (USE_VMS)
+       /* for adding extention (dot + 3ext) */
+       fixp = xmalloc (1 + strlen (hashed_file) + 1 + 3);
+       strcpy (fixp, hashed_file);
+       st = file_status (fixp);
+       free (fixp);
+ #else
        st = file_status (hashed_file);
+ #endif
        if ((st ^ (FS_EXISTS | FS_EXECABLE)) != 0)
  	{
  	  remove_hashed_filename (pathname);
***************
*** 2216,2222 ****
--- 2626,2644 ----
    else if (absolute_program (pathname))
      /* A command containing a slash is not looked up in PATH or saved in
         the hash table. */
+ #if defined (USE_VMS)
+     {
+       /* search suffix */
+       fixp = vmsutil_expand_path (savestring (pathname));
+       command = find_user_command_internal (fixp, FS_EXEC_ONLY);
+       if (command == NULL)
+ 	command = fixp;
+       else
+ 	free (fixp);
+     }
+ #else
      command = savestring (pathname);
+ #endif
    else
      {
        command = find_user_command (pathname);
***************
*** 2234,2247 ****
--- 2656,2688 ----
    /* If we can get away without forking and there are no pipes to deal with,
       don't bother to fork, just directly exec the command. */
    if (nofork && pipe_in == NO_PIPE && pipe_out == NO_PIPE)
+ #if defined (USE_VMS)
+     pid = vmsutil_current_pid;
+ #else
      pid = 0;
+ #endif
    else
+ #if defined (USE_VMS)
+     {
+       vmsutil_save_std_fds (ofds);
+       pid = make_child (savestring (command_line), async);
+     }
+ #else
      pid = make_child (savestring (command_line), async);
+ #endif
  
+ #if defined (USE_VMS)
+   if (pid != 0)
+ #else
    if (pid == 0)
+ #endif
      {
        int old_interactive;
+ #if defined (USE_VMS)
+       int old_subshell_environment = subshell_environment;
+ #endif
  
+ #if !(defined (USE_VMS))
        /* Cancel traps, in trap.c. */
        restore_original_signals ();
  
***************
*** 2250,2255 ****
--- 2691,2697 ----
           in asynchronous children. */
        if (async)
  	setup_async_signals ();
+ #endif
  
        do_piping (pipe_in, pipe_out);
  
***************
*** 2281,2307 ****
--- 2723,2796 ----
  	     result of redirections. */
  	  unlink_fifo_list ();
  #endif /* PROCESS_SUBSTITUTION */
+ #if defined (USE_VMS)
+ 	  vmsutil_wait_status = (EXECUTION_FAILURE);
+ 	  goto _exec_return;
+ #else
  	  exit (EXECUTION_FAILURE);
+ #endif
  	}
  
        if (async)
  	interactive = old_interactive;
  
+ #if defined (USE_VMS)
+       if (!command)
+ 	{
+ 	  vmsutil_wait_status = vms_spawn (words, pathname, args);
+ 	  if (vmsutil_wait_status == EXECUTION_SUCCESS)
+ 	    goto _exec_return;
+ 	  if (vmsutil_wait_status != CLI$_IVVERB)
+ 	    {
+ 	      vmsutil_wait_status = (EX_USAGE << 8);
+ 	      goto _exec_return;
+ 	    }
+ 	}
+ #endif
+ 
        if (!command)
  	{
  	  report_error ("%s: command not found", args[0]);
+ #if defined (USE_VMS)
+ 	  vmsutil_wait_status = (EX_NOTFOUND << 8);
+ 	  goto _exec_return;
+ #else
  	  exit (EX_NOTFOUND);	/* Posix.2 says the exit status is 127 */
+ #endif
  	}
  
+ #if defined (USE_VMS)
+       vmsutil_wait_status = shell_execve_dos (words, command, args, export_env, 1);
+ _exec_return:
+       dispose_word_array (args);
+ 
+       vmsutil_restore_std_fds (ofds);
+ 
+       /* for parent shell */
+       if (pid == vmsutil_current_pid)
+ 	goto disk_command_nofork;
+ 
+       /* restore parent environment */
+       subshell_environment = old_subshell_environment;
+ 
+       goto disk_command_parent;
+ #else
        exit (shell_execve (command, args, export_env));
+ #endif
      }
    else
      {
+ #if defined (USE_VMS)
+ disk_command_parent:
+ #endif
        /* Make sure that the pipes are closed in the parent. */
        close_pipes (pipe_in, pipe_out);
  #if defined (PROCESS_SUBSTITUTION) && defined (HAVE_DEV_FD)
        unlink_fifo_list ();
  #endif
+ #if defined (USE_VMS)
+ disk_command_nofork:
+ #endif
        FREE (command);
      }
  }
***************
*** 2315,2359 ****
--- 2804,2914 ----
  
     The word immediately following the #! is the interpreter to execute.
     A single argument to the interpreter is allowed. */
+ #if defined (USE_VMS)
+ static int
+ execute_shell_script (sample, sample_len, words, command, args, env)
+      unsigned char *sample;
+      int sample_len;
+      WORD_LIST *words;
+      char *command;
+      char **args, **env;
+ #else
  static int
  execute_shell_script (sample, sample_len, command, args, env)
       unsigned char *sample;
       int sample_len;
       char *command;
       char **args, **env;
+ #endif
  {
    register int i;
    char *execname, *firstarg;
    int start, size_increment, larry;
+ #if defined (USE_VMS)
+   WORD_LIST *newwords;
+   char *fixp;
+   char **newargs;
+   int status;
+ #endif
  
    /* Find the name of the interpreter to exec. */
    for (i = 2; whitespace (sample[i]) && i < sample_len; i++)
      ;
  
+ #if defined (USE_VMS)
+   /* support CR/LF */
+   for (start = i;
+        !whitespace (sample[i]) && sample[i] != '\r'
+        && sample[i] != '\n' && i < sample_len;
+        i++)
+ #else
    for (start = i;
         !whitespace (sample[i]) && sample[i] != '\n' && i < sample_len;
         i++)
+ #endif
      ;
  
    execname = xmalloc (1 + (i - start));
    strncpy (execname, (char *) (sample + start), i - start);
    execname[i - start] = '\0';
+ #if defined (USE_VMS)
+   /* search suffix */
+   fixp = vmsutil_expand_path (execname);
+   execname = find_user_command_internal (fixp, FS_EXEC_ONLY);
+   if (execname == NULL)
+     execname = fixp;
+   else
+     free (fixp);
+ 
+   /* research without absolute pathname? */
+   if (access (execname, X_OK) != 0 && (fixp = strrchr (execname, '/')) != NULL)
+     {
+       fixp++;
+       strcpy (execname, fixp);
+       fixp = xmalloc (strlen (execname) + 5);
+       strcpy (fixp, execname);
+       free (execname);
+       execname = find_user_command_internal (fixp, FS_EXEC_ONLY);
+     }
+ #endif
    size_increment = 1;
  
    /* Now the argument, if any. */
    firstarg = (char *)NULL;
+ #if defined (USE_VMS)
+   /* support CR/LF */
+   for (start = i;
+        whitespace (sample[i]) && sample[i] != '\r'
+        && sample[i] != '\n' && i < sample_len;
+        i++)
+ #else
    for (start = i;
         whitespace (sample[i]) && sample[i] != '\n' && i < sample_len;
         i++)
+ #endif
      ;
  
    /* If there is more text on the line, then it is an argument for the
       interpreter. */
+ #if defined (USE_VMS)
+   /* support CR/LF */
+   if (i < sample_len && sample[i] != '\r'
+       && sample[i] != '\n' && !whitespace (sample[i]))
+ #else
    if (i < sample_len && sample[i] != '\n' && !whitespace (sample[i]))
+ #endif
      {
+ #if defined (USE_VMS)
+       /* support CR/LF */
+       for (start = i;
+ 	   !whitespace (sample[i]) && sample[i] != '\r'
+ 	   && sample[i] != '\n' && i < sample_len;
+ 	   i++)
+ #else
        for (start = i;
  	   !whitespace (sample[i]) && sample[i] != '\n' && i < sample_len;
  	   i++)
+ #endif
  	;
        firstarg = xmalloc (1 + (i - start));
        strncpy (firstarg, (char *)(sample + start), i - start);
***************
*** 2364,2373 ****
--- 2919,2941 ----
  
    larry = array_len (args) + size_increment;
  
+ #if defined (USE_VMS)
+   newargs = (char **)xmalloc ((1 + larry) * sizeof (char *));
+   newwords = copy_word_list (words);
+   if (firstarg)
+     newwords = make_word_list (make_word (firstarg), newwords);
+   newwords = make_word_list (make_word (execname), newwords);
+ 
+   for (i = larry - 1; i >= size_increment; i--)
+     newargs[i] = args[i - size_increment];
+ 
+   args = newargs;
+ #else
    args = (char **)xrealloc ((char *)args, (1 + larry) * sizeof (char *));
  
    for (i = larry - 1; i; i--)
      args[i] = args[i - size_increment];
+ #endif
  
    args[0] = execname;
    if (firstarg)
***************
*** 2380,2401 ****
  
    args[larry] = (char *)NULL;
  
    return (shell_execve (execname, args, env));
  }
  
  /* Call execve (), handling interpreting shell scripts, and handling
     exec failures. */
  int
  shell_execve (command, args, env)
       char *command;
       char **args, **env;
  {
  #if defined (isc386) && defined (_POSIX_SOURCE)
    __setostype (0);		/* Turn on USGr3 semantics. */
    execve (command, args, env);
    __setostype (1);		/* Turn the POSIX semantics back on. */
  #else
!   execve (command, args, env);
  #endif /* !(isc386 && _POSIX_SOURCE) */
  
    /* If we get to this point, then start checking out the file.
--- 2948,3081 ----
  
    args[larry] = (char *)NULL;
  
+ #if defined (USE_VMS)
+   status = shell_execve_dos (newwords, execname, args, env, 1);
+   dispose_words (newwords);
+   free (execname);
+   free (newargs);
+   return status;
+ #else
    return (shell_execve (execname, args, env));
+ #endif
  }
  
+ #if defined (USE_VMS)
+ typedef struct dsc {unsigned short len, mbz; char *adr; } Descr;
+ 
+ int
+ vms_spawn (words, command, args)
+      WORD_LIST *words;
+      char *command;
+      char **args;
+ {
+   Descr cmd;
+   int status, vms_status;
+   int i;
+   int len = 1;
+ 
+   for (i=0; args[i]; i++)
+     len = len + strlen (args[i]) + 1;
+ 
+   {
+     char *allargs = (char*) xmalloc (len);
+ 
+     strcpy (allargs, args [0]);
+     strcat (allargs, " ");
+ 
+     for (i=1; args[i]; i++)
+       {
+         strcat (allargs, args[i]);
+         strcat (allargs, " ");
+       }
+     cmd.adr = allargs;
+     cmd.len = len;
+     cmd.mbz = 0;
+ 
+     vms_status = lib$spawn (&cmd,0,0,0,0,0,&status);
+     xfree (allargs);
+ 
+     if ((vms_status & 1) != 1)
+       return (vms_status);
+ 
+     vms_status = status;
+     if ((vms_status & 1) != 1)
+       return (vms_status);
+ 
+     return (EXECUTION_SUCCESS);
+   }
+ }
+ #endif
+ 
  /* Call execve (), handling interpreting shell scripts, and handling
     exec failures. */
+ #if defined (USE_VMS)
+ int
+ shell_execve (command, args, env)
+      char *command;
+      char **args, **env;
+ {
+   return shell_execve_dos ((WORD_LIST *)NULL, command, args, env, 0);
+ }
+ 
+ /*
+  * flag: 0 = execve, 1 = spawnve, 2 = spawnve from exec builtin,
+  */
+ int
+ shell_execve_dos (words, command, args, env, flag)
+      WORD_LIST *words;
+      char *command;
+      char **args, **env;
+      int flag;
+ #else
  int
  shell_execve (command, args, env)
       char *command;
       char **args, **env;
+ #endif
  {
  #if defined (isc386) && defined (_POSIX_SOURCE)
    __setostype (0);		/* Turn on USGr3 semantics. */
    execve (command, args, env);
    __setostype (1);		/* Turn the POSIX semantics back on. */
  #else
! #if defined (USE_VMS)
!   int status = -1;
!   char **newargs;
! #if defined (USE_VMS)
!   int real_pid;
! #endif
! 
!   if (flag)
!     {
! #if defined (USE_VMS)
! #if 0
!       {
! 	char buffer[256];
! 	fprintf (stderr, "stdin: %s\n", getname (0, buffer));
! 	fprintf (stderr, "stdout: %s\n", getname (1, buffer));
! 	fprintf (stderr, "stderr: %s\n", getname (2, buffer));
!       }
! #endif
!       if ((real_pid = vfork ()) < 0)
! 	return (real_pid);
!       else if (real_pid == 0)
! 	{
! 	  if ((status = execve (command, args, env)) >= 0)
! 	    exit (status);
! 	}
!       else
! 	{
! 	  waitpid (real_pid, &status, 0);
! 	  return (status);
! 	}
! #else
!       if ((status = spawnve (P_WAIT, command, args, env)) >= 0)
! 	return status;
! #endif
!     }
!   else
! #endif
!     execve (command, args, env);
  #endif /* !(isc386 && _POSIX_SOURCE) */
  
    /* If we get to this point, then start checking out the file.
